"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.composeFnsXsRight = exports.composeFnsXs = exports.composeFnsRight = exports.composeFns = exports.composeXsRight = exports.composeRight = exports.composeXs = exports.compose = void 0;
/**
 * Compose two unary functions
 * @param f Outer unary function
 * @param g Inner unary function
 * @returns Composite unary function
 */
exports.compose = (f, g) => (x) => f(g(x));
/**
 * Compose an n-ary function with an unary function
 * @param f Outer unary function
 * @param g Inner n-ary function
 * @returns Composite n-ary function
 */
exports.composeXs = (f, g) => (...xs) => f(g(...xs));
/**
 * Compose two unary functions
 * @param f Inner unary function
 * @param g Outer unary function
 * @returns Composite n-ary function
 */
exports.composeRight = (f, g) => exports.compose(g, f);
/**
 * Compose an unary function with an n-ary function
 * @param f Inner n-ary function
 * @param g Outer unary function
 * @returns Composite n-ary function
 */
exports.composeXsRight = (f, g) => exports.composeXs(g, f);
var ts_pipe_compose_1 = require("ts-pipe-compose");
Object.defineProperty(exports, "composeFns", { enumerable: true, get: function () { return ts_pipe_compose_1.composeUnary; } });
Object.defineProperty(exports, "composeFnsRight", { enumerable: true, get: function () { return ts_pipe_compose_1.pipelineUnary; } });
Object.defineProperty(exports, "composeFnsXs", { enumerable: true, get: function () { return ts_pipe_compose_1.compose; } });
Object.defineProperty(exports, "composeFnsXsRight", { enumerable: true, get: function () { return ts_pipe_compose_1.pipeline; } });
